longint sAddBonus(clsScriptContextA* pContext, unsigned char* script)
{
	longint ArgOld = pContext->ArgCount;
	longint progress = ParseScript(pContext, script, 1);
	char* pTemp;

	if (pContext->ArgCount > ArgOld + 3)
	{
		pTemp = (char*) (size_t) pContext->Args[ArgOld + 3].val;
	}
	else
	{
		pTemp = pContext->scriptName;
	}
	AddBonus(pContext->pCurChar, (longint*) (size_t) pContext->Args[ArgOld].val, (longint) pContext->Args[ArgOld + 1].val, (longint) pContext->Args[ArgOld + 2].val, pTemp);

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint PsiDC(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress;
	longint ArgOld;
	longint Disciple;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	if (pContext->nCurFeat != -1)
	{
		Disciple = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
	}
	else
	{
		qprintf("Error in Scripting System (PsiDC)");
		breakpoint("PsiDC\n");
	}

	pContext->pCurChar->DiscipleDC[Disciple] += (longint) pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint SpellDC_a(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress;
	longint ArgOld;
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->pCurChar->SchoolDC[pContext->Args[ArgOld].val] += (longint) pContext->Args[ArgOld + 1].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint SpellDC_b(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress;
	longint ArgOld;
	longint School;
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	if (pContext->nCurFeat != -1)
	{
		School = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
	}
	else if (pContext->pCurChar->Specialised)
	{
		School = pContext->pCurChar->School;
	}
	else
	{
		qprintf("Error in Scripting System (SpellDX)\n");
		breakpoint("SpellDC_b");
	}

	pContext->pCurChar->SchoolDC[School] += (longint) pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;
	return(progress);
}

inline longint AppendText(clsScriptContextA* pContext, unsigned char* script, longint NewLine)
{
	longint i;

	char AppendText_tmpchar[12];
	longint progress;
	longint ArgOld;
	qprinta(2)(" Appending Text:");

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	for (i = ArgOld;i < pContext->ArgCount;i++)
	{
		if (pContext->Args[i].type == 0)
		{
			sprintf(AppendText_tmpchar, "%" PRINTFINT "", pContext->Args[i].val);
			*pContext->pCurText += AppendText_tmpchar;
		}
		else if (pContext->Args[i].type == 1)
		{
			*pContext->pCurText += (char*) (size_t) pContext->Args[i].val;
		}
	}

	if (NewLine)
	{
		*pContext->pCurText += "\n";
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint AppendText_a(clsScriptContextA* pContext, unsigned char* script)
{
	return(AppendText(pContext, script, 0));
}

longint AppendText_b(clsScriptContextA* pContext, unsigned char* script)
{
	return(AppendText(pContext, script, 1));
}

longint sAddFeatD(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;
	longint i;

	longint* featsyet;
	if (pContext->pCurChar->sAddfeatsyet == 0)
	{
		featsyet = &pContext->pCurChar->FeatCount;
	}
	else
	{
		featsyet = pContext->pCurChar->sAddfeatsyet;
	}

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	for (i = 0;i < pContext->pCurChar->FeatCount;i++)
	{
		if (pContext->pCurChar->Feats[i] == pContext->Args[ArgOld + 1].val)
		{
			AddFeat(pContext->pCurChar, (longint) pContext->Args[ArgOld].val, featsyet, pContext->pCurChar->FeatDependancy[i]);
		}
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

inline longint sAddFeat(clsScriptContextA* pContext, unsigned char* script, longint dep = 0)
{
	longint progress, ArgOld;
	longint nFeat, nDep;
	longint i;
	longint* featsyet;

	if (pContext->pCurChar->sAddfeatsyet == 0)
	{
		featsyet = &pContext->pCurChar->FeatCount;
	}
	else
	{
		featsyet = pContext->pCurChar->sAddfeatsyet;
	}

	qprinta(2)(" Adding feat:");

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	nFeat = pContext->Args[ArgOld].val;

	if (dep == 0)
	{
		nDep = -2;
		AddFeat(pContext->pCurChar, nFeat, featsyet, nDep);
	}
	else
	{
		for (i = ArgOld + 1;i < pContext->ArgCount;i++)
		{
			if (pContext->Args[i].type == 0)
			{
				nDep = pContext->Args[i].val;
			}
			else if (pContext->Args[i].type == 1)
			{
				if (Source.FeatSource[nFeat].DepType == DEP_WEAPON)
				{
					nDep = GetEquipNumber((char*) (size_t) pContext->Args[i].val);
				}
				else if (Source.FeatSource[nFeat].DepType == DEP_SPELL)
				{
					nDep = GetSpellNumber((char*) (size_t) pContext->Args[i].val);
				}
				else if (Source.FeatSource[nFeat].DepType == DEP_SKILL)
				{
					nDep = GetSkillNumber((char*) (size_t) pContext->Args[i].val);
				}
				else
				{
					qprintf("Scripting Error\nFeat doesnt match for dependancy: %s\n", Source.FeatSource[nFeat].Name.buffer);
					quitprog(true, pContext->pCurChar->CreationTemplate);
				}
			}
			else
			{
				qprintf("Scripting Error\nInvalid Argument for Feat: %s\n",  Source.FeatSource[nFeat].Name.buffer);
				quitprog(true, pContext->pCurChar->CreationTemplate);
			}

			AddFeat(pContext->pCurChar, nFeat, featsyet, nDep);
		}
	}

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint sAddFeat_a(clsScriptContextA* pContext, unsigned char* script)
{
	return(sAddFeat(pContext, script, 1));
}

longint sAddFeat_b(clsScriptContextA* pContext, unsigned char* script)
{
	return(sAddFeat(pContext, script, 0));
}

longint sFeatPresent(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;
	longint retval;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	retval = FeatPresent(pContext->pCurChar, pContext->Args[ArgOld].val, pContext->pCurChar->FeatCount);

	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

longint sIsRace(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;
	longint retval;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	retval = (pContext->pCurChar->Race == pContext->Args[ArgOld].val);

	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

longint sIsClass(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;
	longint retval = 0, nClass;
	longint i;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	nClass = pContext->Args[ArgOld].val;

	for (i = 0;i < pContext->pCurChar->ClassCount;i++)
	{
		if (pContext->pCurChar->Classes[i] == nClass)
		{
			retval = 1;
			break;
		}
	}

	pContext->ArgCount = ArgOld;
	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

inline longint BoostSkill(clsScriptContextA* pContext, unsigned char* script, longint FeatDep = 0, longint Rank = 0, longint Bonus = 0)
{
	longint progress, ArgOld;

	longint nSkill, nLevel, nBonus = -1;

	qprinta(2)(" Boosting Skill:");

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);
	
	if (FeatDep)
	{
		nSkill = pContext->pCurChar->FeatDependancy[pContext->nCurFeat];
		nLevel = pContext->Args[ArgOld].val;
		if (Bonus)
		{
			nBonus = pContext->Args[ArgOld + 1].val;
		}
	}
	else
	{
		nSkill = pContext->Args[ArgOld].val;
		nLevel = pContext->Args[ArgOld + 1].val;
		if (Bonus)
		{
			nBonus = pContext->Args[ArgOld + 2].val;
		}
	}

	BoostSkillA(pContext->pCurChar, nSkill, nLevel, Rank, nBonus, pContext->scriptName);

	pContext->ArgCount = ArgOld;
	return(progress);
}

longint BoostSkill_a(clsScriptContextA* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script));
}

longint BoostSkill_b(clsScriptContextA* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1));
}

longint BoostSkill_c(clsScriptContextA* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1, 1));
}

longint BoostSkill_d(clsScriptContextA* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 1, 0, 1));
}

longint BoostSkill_e(clsScriptContextA* pContext, unsigned char* script)
{
	return(BoostSkill(pContext, script, 0, 0, 1));
}

longint sGetSkillLevel(clsScriptContextA* pContext, unsigned char* script)
{
	longint ArgOld, progress;
	longint nSkill;
	longint retval;

	qprinta(2)(" Catching Skill Level:");
	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);
	nSkill = pContext->Args[ArgOld].val;

	pContext->ArgCount = ArgOld;

	retval = GetSkillLevel(pContext->pCurChar, nSkill);

	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = retval;
	pContext->ArgCount++;

	return(progress);
}

longint GetArmorType(clsScriptContextA* pContext, unsigned char* script)
{
	longint MaxArmor = -1;
	longint i;

	for (i = 0;i < pContext->pCurChar->EquipCount;i++)
	{
		if (pContext->pCurChar->Equipment[i].EquipType == EQUIP_ARMOR && pContext->pCurChar->Equipment[i].Type > MaxArmor)
		{
			MaxArmor = pContext->pCurChar->Equipment[i].Type;
		}
	}

	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	pContext->Args[pContext->ArgCount].type = 0;
	pContext->Args[pContext->ArgCount].val = MaxArmor;
	pContext->ArgCount++;

	return(ParseScript(pContext, script, 1));
}

longint sRandom(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;

	mCheckOverflow(pContext->ArgCount, MAX_ARGS, "Argument Count", "MAX_ARGS");
	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->Args[ArgOld].val = random(pContext->pCurChar->Context.seeda, pContext->Args[ArgOld].val, pContext->Args[ArgOld + 1].val, "Random by script");
	pContext->ArgCount = ArgOld + 1;

	return(progress);
}

longint sEnhence(clsScriptContextA* pContext, unsigned char* script)
{
	longint progress, ArgOld;

	ArgOld = pContext->ArgCount;
	progress = ParseScript(pContext, script, 1);

	pContext->Args[ArgOld].val = Enhence(pContext->pCurChar->Context.seeda, pContext->Args[ArgOld].val);

	return(progress);
}

longint SubText(clsScriptContextA* pContext, unsigned char* script)
{
	pContext->pCurText = pContext->pCurSubText;
	return(ParseScript(pContext, script, 1));
}

longint MainText(clsScriptContextA* pContext, unsigned char* script)
{
	pContext->pCurText = pContext->pCurMainText;
	return(ParseScript(pContext, script, 1));
}

longint sGetElement(clsScriptContextA* pContext, unsigned char* script)
{
	longint ArgOld, progress;
	longint Num;

	ArgOld = pContext->ArgCount;

	progress = ParseScript(pContext, script, 1);

	if (pContext->ArgCount == ArgOld)
	{
		Num = -1;
	}
	else
	{
		Num = pContext->Args[ArgOld].val;
	}

	pContext->Args[ArgOld].val = (longint) (size_t) GetElement(pContext->pCurChar->Context.seeda, Num, 1);
	pContext->Args[ArgOld].type = 1;
	pContext->ArgCount = ArgOld + 1;

	return(progress);
}

longint SetEquip(clsScriptContextA* pContext, unsigned char* script)
{
	longint i;
	for (i = 0;i < pContext->pCurChar->EquipCount;i++)
	{
		if (pContext->pCurChar->Equipment[i].ID == pContext->pCurChar->FeatDependancy[pContext->nCurFeat])
		{
			pContext->pCurEquip = &pContext->pCurChar->Equipment[i];
			goto Found;
		}
	}
	pContext->pCurEquip = &eDumpEquip;
Found:
	return(ParseScript(pContext, script, 1));
}

longint DoAllEq(clsScriptContextA* pContext, unsigned char* script)
{
	longint i, progress;
	clsEquip* EquipOld;
	EquipOld = pContext->pCurEquip;

	if (pContext->pCurChar->EquipCount)
	{
		for (i = 0;i < pContext->pCurChar->EquipCount;i++)
		{
			pContext->pCurEquip = &pContext->pCurChar->Equipment[i];
			progress = ParseScript(pContext, script, 1);
		}
	}
	else
	{
		progress = SkipScript(script, 1);
	}

	pContext->pCurEquip = EquipOld;
	return(progress);
}

longint RedirectSymbolsA(char* pSymbolCheck, char* RedirFuncs, size_t &AddrPos)
{
	mRedirFunction("func_appendtext_a", AppendText_a)
	mRedirFunction("func_appendtext_b", AppendText_b)
	mRedirFunction("func_addfeat_a", sAddFeat_a)
	mRedirFunction("func_addfeat_b", sAddFeat_b)
	mRedirFunction("func_addfeat_c", sAddFeat_a)
	mRedirFunction("func_addfeat_d", sAddFeatD)
	mRedirFunction("func_setequip", SetEquip)
	mRedirFunction("func_subtext", SubText)
	mRedirFunction("func_maintext", MainText)
	mRedirFunction("func_featpresent", sFeatPresent)
	mRedirFunction("func_israce", sIsRace)
	mRedirFunction("func_isclass", sIsClass)
	mRedirFunction("func_boostskill_a", BoostSkill_a)
	mRedirFunction("func_boostskill_b", BoostSkill_b)
	mRedirFunction("func_boostskill_c", BoostSkill_c)
	mRedirFunction("func_boostskill_d", BoostSkill_d)
	mRedirFunction("func_boostskill_e", BoostSkill_e)
	mRedirFunction("func_getskilllevel", sGetSkillLevel)
	mRedirFunction("func_getarmortype", GetArmorType)
	mRedirFunction("func_random", sRandom)
	mRedirFunction("func_enhence", sEnhence)
	mRedirFunction("func_getelement", sGetElement)
	mRedirFunction("alleq_order", DoAllEq)
	mRedirFunction("func_spelldc_a", SpellDC_a)
	mRedirFunction("func_spelldc_b", SpellDC_b)
	mRedirFunction("func_psidc", PsiDC)
	mRedirFunction("func_addbonus", sAddBonus)
	{
		return(0);
	}
	return(1);
}
