class xRestartChar
{
};

class clsMonsterDescSource
{
public:
	string FileName;
	string Content;
	longint MR;
};

class clsBonus
{
public:
	size_t Pointer;
	longint Value;
	longint Type;
	string Text;
};

template <class T> class ListA
{
public:
	ListA<T>* NextElem;
	T val;

	ListA()
	{
		NextElem = NULL;
	}

	~ListA()
	{
		if (NextElem)
		{
			delete NextElem;
			NextElem = NULL;
		}
	}
};

template <class T> class List : public T
{
public:
	List<T>* NextElem;

	List()
	{
		NextElem = NULL;
	}

	~List()
	{
		if (NextElem)
		{
			delete NextElem;
			NextElem = NULL;
		}
	}
};

template <class T> class p_nofree
{
public:
	T* ptr;

	T* operator =(T* ptr2)
	{
		return(ptr = ptr2);
	}

	inline operator T*() const
	{
		return(ptr);
	}
};

template <class T> class p
{
public:
	T* ptr;

	p()
	{
		ptr = NULL;
	}

	p(T *setPtr)
	{
		ptr = setPtr;
	}

	~p()
	{
		freep();
	}

	void freep()
	{
		if (ptr)
		{
			freel(ptr);
			ptr = NULL;
		}
	}

	T* operator =(T* ptr2)
	{
		return(ptr = ptr2);
	}

	inline operator T*() const
	{
		return(ptr);
	}
};

struct structBaseFrame
{
	int DrawType;
	int CalcType;
	int AllowEpic;
	__int64 LastMonster;
};

struct GroupTemplate
{
	__int64 CharCount;
	__int64 FullCR;
};

struct CharTemplate
{
	__int64 TemplateType;
	__int64 AttributeType;
	__int64 MinLevel;
	__int64 MaxLevel;
	longint* Class;
	__int64 ClassCount;
	longint* AttributePreset;
	__int64 Monster;
	__int64 MonsterName;
	__int64 MonsterNameHD;
	__int64 MonsterNameTemplate;
	__int64 Mixed;
	__int64 Treasure;
	__int64 NPCClass;
	__int64 Race;

	__int64 TreasureMin;
	__int64 TreasureMax;

	__int64 Life;

	bool Saved;

	structBaseFrame BaseFrame;
	int Reproduce;

	struct seedstru
	{
		unsigned long seed[517];
	} seed;
	struct restru
	{
		__int64 retemp[REPRODUCE_SAVE];
		__int64 repos;
	} re;
	struct consolestru
	{
		unsigned char order;
		char manual;
		char ChooseClass;
		bool UseIsaac;
		__int64 param;
	} console[CONSOLE_SAVE];
	unsigned int consolepos;
};

struct clsSourceFake
{
	basestring Name;
};

struct clsMonsterSource
{
#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
	logstring Name;
	logstring MonsterDesc;
	longint CR;
	longint Type;
	longint Size;
	longint Epic;
	longint HD;
	longint HDType;
	longint TPBonus;
	longint RWRef;
	longint RWWil;
	longint RWZaeh;
	longint Attr[ATTRIBUTE_COUNT];
	longint AC;
	longint HDMin;
	longint HDMax;
	longint HDInc;
	longint HDInc2;
	longint Init;
	longint Speed;
	longint OrgMin;
	longint OrgMax;
	longint Mixed;
	longint Treasure;
	longint AttackBonus[6];
	longint AttackNumber[6];
	longint AttackRed[6];
	longint DamageA[6];
	longint DamageB[6];
	longint DamageC[6];
	logstring AttackType[6];
	longint AlternateAttack[6];
	longint AttackCount;
	longint Feats[6];
	longint FeatCount;
	longint Skills[7];
	longint SkillLevels[7];
	longint SkillCount;
	char* SpellChar;
	longint ClericSpells;
	char* Familiar;
	p<longint> AbbilityCode;
	longint MR;
};

struct clsPowerSource
{
	logstring Name;
	longint Psion;
	longint PsychicW;
	longint Attribute;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEffectSource
{
	logstring Name;
	longint Weapon;
	longint Armor;
	longint Shield;
	longint Helmet;
	longint Gloves;
	longint Boots;
	longint Belt;
	longint Cloak;
	longint Ring;
	longint Amulet;
	longint Westment;
	longint Bracers;
	longint Fight;
	longint Magic;
	longint Shadow;
	longint Divine;
	longint Multi;
	longint Cost;
	longint Cost2;
	longint Quality;
	char* Script;
	p<longint> SkillCode;
	char* Variable;
	longint Ranged;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSpellSource
{
	basestring Name;
	longint Probability;
	longint* ClassLevels;
	longint DomainCount;
	longint DomainLevel;
	longint Domains[2];
	longint School;
	longint Convert;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEquipSource
{
	logstring Name;
	longint EquipType;
	longint Damage1;
	longint Damage2;
	longint Damage3;
	longint Size;
	longint Type;
	longint Critical;
	longint CriticalMultiplier;
	longint CriticalMultiplier2;
	longint AttackType;
	longint* Probability;
	longint* RaceProbability;
	longint StdProb;
	longint Armor;
	longint MaxDex;
	longint Malus;
	longint SpellFailure;
	longint Metallic;
	longint SpecialType;
	longint MinLevel;
	longint Rare;
	longint Price;
	char* Script;
	longint ForbidEffects;
	longint Amount;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsEquip
{
	longint ID;
	longint EquipType;
	longint Enhencement;
	longint Effect[MAX_EFFECTS];
	longint EffectVariable[MAX_EFFECTS];
	longint EffectCount;
	longint EffectCountA;
	longint ForceEffects;
	longint Damage1;
	longint Damage2;
	longint Damage3;
	longint Size;
	longint Type;
	longint Critical;
	longint CriticalMultiplier;
	longint CriticalMultiplier2;
	longint CriticalBonus;
	longint AttackType;
	longint Armor;
	longint MaxDex;
	longint Malus;
	longint SpellFailure;
	longint Metallic;
	longint AttackBonus;
	longint AttackBonusA;
	longint TwoWeapon;
	longint TwoWeaponSecond;
	longint TwoHand;
	longint MaxStr;
	longint Primary;
	longint Secondary;
	longint Value;
	longint BaseValue;
	longint Adamantine;
	longint Mithril;
	longint Mercury;
	longint Masterwork;
	longint ShieldUsed;
	longint IncludeInTreasure;
	longint MaxEnh;

	struct clsEquip_strings
	{
		string EquipDesc;
		string EffectDesc[MAX_EFFECTS];
	} strings;

	longint Specific;

	longint FinalAttackBonus;
	longint FinalMalus;
	longint FinalDamage3;
};

struct clsRaceSource
{
	logstring Name;
	longint Probability;
	longint Size;
	longint PreferedAttackType;
	char* Script;
	longint RaceModBin[6];
	longint Range;
	longint SubRaceBin;
	longint HGMod;
	char* RaceFeats;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsChar;

struct clsVolatileChar
{
	longint HG;

	List<clsBonus>* Boni;

	longint CRPosCount;
	longint CRPosHD[32];
	longint CRPosTemplate[32];
	longint CRPosCR[32];

	longint Profiled;
	longint ProfileStrength;
	longint Profile;

	longint Mixed;
	longint MixedHG;

	longint HasTemplate;

	longint Rel;
	longint NPCClass;

	__int64 CreationTime;
	__int64 MixedTime;
	longint DisplayTime;

	longint Attributes[ATTRIBUTE_COUNT];
	longint Mods[ATTRIBUTE_COUNT];
	longint IgnoreAttr[ATTRIBUTE_COUNT];

	longint ClassCount;
	longint Classes[MAX_CLASSES];
	longint DummyClass[MAX_CLASSES];
	longint DummyClassClericSpells[MAX_CLASSES];
	longint Level;
	longint MonsterLevel;
	longint Levels[MAX_CLASSES];
	longint LevelsClassic[MAX_CLASSES];
	longint CasterLevel[MAX_CLASSES];

	longint Life;
	longint LifeBonus;
	longint TPLeft;
	
	longint GA;
	longint GASize;
	longint GAMelee;
	longint GAShot;
	longint GAMeleeAttr;
	longint GAShotAttr;
	longint GAMeleeRest;
	longint GAShotRest;
	longint GAEpic;
	
	longint RWEpic;
	longint RWRef;
	longint RWWil;
	longint RWZaeh;
	longint RWRefBase;
	longint RWWilBase;
	longint RWZaehBase;
	longint RWRefAttr;
	longint RWWilAttr;
	longint RWZaehAttr;
	longint RWRefMage;
	longint RWWilMage;
	longint RWZaehMage;
	longint RWRefRest;
	longint RWWilRest;
	longint RWZaehRest;
	
	longint FeatCount;
	longint Feats[MAX_FEATS];
	longint FeatDependancy[MAX_FEATS];
	longint FeatDone[MAX_FEATS];
	longint FeatTypeRequired[FEAT_TYPE_COUNT];
	longint WeaponArmorShieldFeats;
	longint InbornLeft;
	longint BonusFeatCountLast;
	longint BonusFeatCount;

	longint AttackType[2];
	longint AttackTypeCount;
	longint Attacks;
	longint Attacks2;
	longint BonusAttacks;
	longint AttacksOpportunity;
	longint MonkAttacks;
	
	longint EquipCount;
	clsEquip Equipment[MAX_EQUIP];
	longint EquipTreasureCount;
	longint EquipTreasureStart;
	longint RingMax;
	longint dart;
	
	longint Skills[MAX_SKILLS];
	longint SkillRank[MAX_SKILLS];
	longint SkillRank2[MAX_SKILLS];
	longint SkillBonus[MAX_SKILLS];
	longint FinalSkillBonus[MAX_SKILLS];
	longint SkillMalus[MAX_SKILLS];
	longint SkillTotal[MAX_SKILLS];
	longint SkillCount;
	longint SkillCountReal;
	longint SkillRequired[MAX_SKILLS];
	longint BonusSkillPointCount;
	longint BonusSkillPointCountLast;

	longint Race;
	longint SubRace;

	longint SpellsKnownCount[MAX_CLASSES][10];
	longint SpellList[MAX_CLASSES][10][10];
	longint SpellsPerDayCount[MAX_CLASSES][10];
	longint SpellListCount[MAX_CLASSES][10];
	longint BonusSpells;
	longint BonusSpellLevelMin;
	longint BonusSpellLevelMax;
	longint HighestSpell;
	longint SpellFailure;
	longint TargetClass;

	longint Domains[MAX_DOMAINS];
	longint DomainCount;
	longint DomainSpells[10];
	longint DomainSpellCount;

	longint Specialised;
	longint School;
	longint SchoolForbidden[MAX_SCHOOLS];

	longint SchoolDC[MAX_SCHOOLS];
	longint ArcaneDC;
	longint DivineDC;
	longint GeneralDC;

	longint AC;
	longint ACArmor;
	longint ACShield;
	longint ACDex;
	longint ACSize;
	longint ACRest;
	longint MaxDex;
	longint ArmorMalus;
	
	float Range;
	
	longint MR;
	longint MRBonus;
	longint againstMR;
	
	longint SpecialAbbilities;
	longint Lores;
	longint Arcanas;
	longint HierophantAbilities;

	longint Initiative;
	longint InitiativeRest;
	longint InitiativeDex;
	
	longint AttackMod;
	longint DmgMod;

	longint Money;
	longint MoneyRest;
	longint Treasure;
	longint TreasureLeft;
	longint TreasureSellValue;

	longint UnarmedDamage1;
	longint UnarmedDamage2;
	
	longint PowerPoints;
	longint MainDisciple;
	longint DiscipleDC[ATTRIBUTE_COUNT];
	longint PsionicDC;
	longint CrystalCount;
	longint CombatModes;
	
	longint Monster;
	longint MonsterName;
	longint MonsterType;
	longint MAttackBonus[6];
	longint MAttackNumber[6];
	longint MAttackRed[6];
	longint MDamageA[6];
	longint MDamageB[6];
	longint MDamageC[6];
	longint MAlternateAttack[6];
	longint MAttackCount;
	longint MSize;
	longint MonsterTWType;
	longint MonsterSize;

	longint SneakDmg;
	longint Evasion;
	longint Smite;
	longint Dex2AC;
	longint UncannyDodge;
	longint LowLightVision;
	longint DarkVision;
	longint ShareSpells;
	longint EmpathicLink;
	longint SpeakWithMaster;
	longint Concealment;
	longint LayOnHands;
	longint SacretDefense;
	longint PoisonUse;
	longint SurpremeCleave;
	longint TouchReach;

	longint FinalSpellFailure;
	longint FinalArmorMalus;
	longint FinalLife;
	longint FinalMR;
	longint FinalAttacks;

	longint protection;
	longint protectionmissed;
	longint classlevel;
	longint* sAddfeatsyet;
	bool NoScriptVarSet;

	longint Familiar;
	clsChar* pFamiliar;

	longint AnimalCompanion;
	longint AnimalCount;
	clsChar* pAnimalCompanion;

	longint Mount;
	clsChar* pMount;

	longint Servant;
	clsChar* pServant;

	clsVolatileChar()
	{
		pFamiliar = NULL;
		pAnimalCompanion = NULL;
		pMount = NULL;
		pServant = NULL;
		Boni = NULL;
	}

	~clsVolatileChar()
	{
		if (Boni)
		{
			delete Boni;
			Boni = NULL;
		}
	}
};

struct clsChar : public clsVolatileChar
{
	struct clsChar_strings
	{
		string CharText;
		string CharTextPrimary;
		string CharTextSecondary;
		string CharTextTwo;
		string MAttackType[6];
		string tempstring1, tempstring2;
	} strings;

	CharTemplate* CreationTemplate;

	struct clsCharContext
	{
		char* EffectDone;
		unsigned longint* AgainDep;
		char* FeatNotAgain;
		longint* ClassSkills;
		short int* SpecialCount;
		char tempstring[SMALL_BUFFER_LEN];
		char tempout[BUFFER_LEN];
		clsChar* CDummy;
		CharTemplate* CTDummy;
		unsigned long* seeda;
		longint FetchVarCounter[26];
		longint *TempProb, *TempProb2, *EffectProb, *EffectProb2, *SpecificProb, *FeatProb, *FeatProb2, *FeatProb3, *MonsterProb, *MonsterProb2, *MonsterProb3, *MonsterProb4, *HenchmenProb, *HenchmenProb2;
	} Context;

	longint DummyChar;
	clsChar* dummySource;
	longint HenchmenChar;

	clsChar()
	{
		dummySource = NULL;
		HenchmenChar = DummyChar = 0;
	}

	void delete_subchars()
	{
		if (pFamiliar)
		{
			delete pFamiliar;
			pFamiliar = NULL;
		}
		if (pAnimalCompanion)
		{
			delete[] pAnimalCompanion;
			pAnimalCompanion = NULL;
		}
		if (pMount)
		{
			delete pMount;
			pMount = NULL;
		}
		if (pServant)
		{
			delete pServant;
			pServant = NULL;
		}
	}

	~clsChar()
	{
		delete_subchars();
	}
};

struct clsCharSource
{
	longint Count;
	logstring Name;
	longint TW;
	longint AttributePriority[ATTRIBUTE_COUNT];
	longint Probability;
	longint GA;
	longint RWRef;
	longint RWWil;
	longint RWZaeh;
	longint PreferedAttack;
	longint ForceAttack;
	longint Skills;
	longint Prestige;
	longint MaxLevel;
	longint MaxLevelA;
	char* Script;
	char* ClassFeats;
	longint SpellType;
	longint SpellType2;
	longint IncreaseSpellType;
	longint SpontanCast;
	longint SpontanCast2;
	longint Domains;
	longint Specialize;
	longint PowerType;
	p<longint> ReqCode;
	p<longint> SkillCode;
	p<longint> FeatCode;
	logstring BonusFeatType;
	logstring BonusFeats;
	longint EpicFeats;
	longint SpellFailure;
	longint UseEffects;
	longint AttachClassNum;
	longint NoEq;
	longint PsionicDisciple;
	longint PsiCrystal;
	longint ForceWeaponType;
	longint NaturalEnhence;
	longint NPC;
	longint SpellAttr;
	longint BonusClassSkills;
	longint ForceWeaponNum;
	longint NoMetal;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsFeatSource
{
	logstring Name;
	longint* Probability;
	longint MultipleTimes;
	longint Epic;
	p<longint> ReqCode;
	longint CopyDepFrom;
	p<longint> SkillCode;
	longint DepType;
	char* Script;
	longint AttackDep;
	longint FeatType;
	logstring Text;
	longint Inborn;
	longint* Rel;
	longint RelCount;
	longint Standard;
	longint Exclusive;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSkillSource
{
	logstring Name;
	longint* Prob;
	longint Attr;
	p<longint> SynCode;
	longint Untrained;
	longint ArmorMalus;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsDomainSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsMonsterTypeSource
{
	logstring Name;
	longint GAType;
	longint RWRefType;
	longint RWWilType;
	longint RWZaehType;
	longint Mixed;
	longint MixedEq;
	longint Skills;
	longint Feats;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsRegionSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSchoolSource
{
	logstring Name;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSizeSource
{
	logstring Name;
	longint Mods[3];
	longint AC;
	longint SizeMod;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsAbbilitySource
{
	logstring Name;
	logstring Text;
	char* Script;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSpecialSource
{
	logstring Name;
	longint Type;
	longint SpellLevel;
	char* Script;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsTemplateSource
{
	logstring Name;
	char* CRScript;
	longint Mixed;
	logstring ForceType;
	logstring ForbitType;
	char* Script;
	longint AttributeMod[ATTRIBUTE_COUNT];
	logstring NewType;
	logstring TemplateDesc;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsBonusSource
{
	logstring Name;
	longint Stack;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct ProfileFeatStruct
{
	longint Feat;
};

struct ProfileClassStruct
{
	longint Class;
	longint Level;
};

struct ProfileWeaponStruct
{
	longint Weapon;
};

struct ProfileSkillStruct
{
	longint Skill;
	longint MinLvl;
	longint MaxLvl;
};

struct ProfileSpellStruct
{
	longint Spell;
	longint MaxNum;
};

struct ProfileEffectStruct
{
	longint Effect;
};

struct clsSpecificSource
{
	logstring Name;
	longint On;
	longint Price;
	char* script;
	p<longint> SkillCode;
	longint Fight;
	longint Mage;
	longint Shadow;
	longint Divine;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct ProfileStruct
{
	char ProfileName[256];
	
	ProfileClassStruct Classes[MAX_PROFILE_CLASSES];
	longint ClassCount;

	ProfileWeaponStruct Weapons[MAX_PROFILE_WEAPONS];
	longint WeaponCount;
	
	ProfileFeatStruct Feats[MAX_PROFILE_FEATS];
	longint FeatCount;

	ProfileSkillStruct Skills[MAX_PROFILE_SKILLS];
	longint SkillCount;
	
	ProfileSpellStruct Spells[MAX_PROFILE_SPELLS];
	longint SpellCount;

	ProfileEffectStruct Effects[MAX_PROFILE_EFFECTS];
	longint EffectCount;

	longint Specials[MAX_PROFILE_SPECIALS];
	longint SpecialCount;

	longint Armor;
	longint Shield;
	longint ArmorType;
	longint ShieldUse[2];

	longint AttackType[2];

	longint Race;
	longint PreferedSchool;

	longint AttributePriority[ATTRIBUTE_COUNT];

	longint MinLevel;

#ifdef QON_ENABLE_LOG_STRING
#include "../qon/malloclog/newlog.h"
#endif
};

struct clsSource
{
	clsCharSource*	CharSource;
	longint CharSourceCount;
	clsFeatSource* FeatSource;
	longint FeatSourceCount;
	clsEquipSource* EquipSource;
	longint EquipSourceCount;
	clsSkillSource* SkillSource;
	longint SkillSourceCount;
	clsRaceSource* RaceSource;
	longint RaceSourceCount;
	clsSpellSource* SpellSource;
	longint SpellSourceCount;
	clsPowerSource* PowerSource;
	longint PowerSourceCount;
	clsEffectSource* EffectSource;
	longint EffectSourceCount;
	clsSpecificSource* SpecificSource;
	longint SpecificSourceCount;
	clsMonsterSource* MonsterSource;
	longint MonsterSourceCount;
	longint* MonsterCR;

	ProfileStruct* Profiles;
	longint ProfileCount;

	clsSchoolSource* SchoolSource;
	longint SchoolSourceCount;
	clsSizeSource* SizeSource;
	longint SizeSourceCount;
	clsMonsterTypeSource* MonsterTypeSource;
	longint MonsterTypeSourceCount;
	clsDomainSource* DomainSource;
	longint DomainSourceCount;
	clsTemplateSource* TemplateSource;
	longint TemplateSourceCount;
	clsRegionSource* RegionSource;
	longint RegionSourceCount;
	clsAbbilitySource* AbbilitySource;
	longint AbbilitySourceCount;

	clsSpecialSource* SpecialSource;
	longint SpecialSourceCount;
	clsBonusSource* BonusSource;
	longint BonusSourceCount;

	string AttributeNames[ATTRIBUTE_COUNT];

	longint StartMoney[51];
	longint Treasure[51];

	longint EquipTypeFeats[3][3];

	char* lpSymbolStart;
	unsigned longint dwSourceCountMax;
};

struct clsTempFeatSource
{
	basestring ReqStr;
	basestring SkillStr;
};
struct clsTempCharSource
{
	basestring Derrive;
	basestring SkillStr;
	basestring ReqStr;
	basestring CopySpellList;
	basestring AttachClass;
	basestring ForceWeapon;
	basestring FeatStr;
};
struct clsTempEffectSource
{
	basestring SkillBoost;
};
struct clsTempSkillSource
{
	basestring Synergy;
};
struct clsTempSpecificSource
{
	basestring SkillBoost;
};
struct clsTempRaceSource
{
	basestring SubRace;
};
struct clsTempMonsterSource
{
	basestring Abbilities;
};

struct clsTempSource
{
	clsTempCharSource* CharSource;
	clsTempFeatSource* FeatSource;
	clsTempEffectSource* EffectSource;
	clsTempSkillSource* SkillSource;
	clsTempSpecificSource* SpecificSource;
	clsTempRaceSource* RaceSource;
	clsTempMonsterSource* MonsterSource;

	List<clsMonsterDescSource>* MonsterDesc;

	clsTempSource()
	{
		ZeroMemory(this, sizeof(clsTempSource));
	}
};

extern "C" clsSource Source;

#ifdef INCLUDE_REBUILD
extern "C" clsTempSource TempSource;
#endif

class clsScriptContextA : public clsScriptContext
{
public:
	clsChar* pCurChar;
	clsEquip* pCurEquip;
	longint nCurFeat;
	string *pCurText, *pCurMainText, *pCurSubText;
};

struct clsThreadData
{
	longint n;
	longint start;
	longint end;
	bool primary;
	HANDLE handle;
};
