void SetCharSource(char** Vals, void* pChar, void* pTempChar, longint Number, bool header)
{
	longint i;

	static longint prob, tw, ga, rwref, rwwil, rwzaeh, attack, skills, prestige, maxlvl, name, attr[ATTRIBUTE_COUNT], valcount;
	static longint scriptpos, spellpos, incspellpos, spontanpos, domainpos, specialpos, powerpos, reqpos, skillreqpos;
	static longint classfeatpos, featreqpos, bonusfeattypepos, bonusfeatpos, epicfeatpos, spellfailpos, useeffectspos;
	static longint attachclasspos, noeqpos, psidispos, psicryspos, forceattackpos, forceweapontypepos, naturalenhpos;
	static longint derrivepos, copyspellpos, npcpos, spellattrpos, bonusclassskillpos, spelltype2pos;
	static longint forceweaponpos, nometalpos;

	char AttributeNameShort[ATTRIBUTE_NAME_SHORT_BUFFER];

	if (header)
	{
		prob = GetValNumber(Vals, "Probability", Number);
		ga = GetValNumber(Vals, "GAType", Number);
		rwref = GetValNumber(Vals, "Ref", Number);
		rwwil = GetValNumber(Vals, "Wil", Number);
		rwzaeh = GetValNumber(Vals, "Zh", Number);
		attack = GetValNumber(Vals, "Attack", Number);
		skills = GetValNumber(Vals, "Skills", Number);
		prestige = GetValNumber(Vals, "Prest", Number);
		maxlvl = GetValNumber(Vals, "MaxLvl", Number);
		name = GetValNumber(Vals, "Name", Number);
		tw = GetValNumber(Vals, "TW", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		spellpos = GetValNumber(Vals, "SpellType", Number);
		spelltype2pos = GetValNumber(Vals, "SpellType2", Number);
		incspellpos = GetValNumber(Vals, "IncreaseSpellType", Number);
		spontanpos = GetValNumber(Vals, "SpontanCast", Number);
		domainpos = GetValNumber(Vals, "Domains", Number);
		specialpos = GetValNumber(Vals, "Specialize", Number);
		powerpos = GetValNumber(Vals, "PowerType", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillreqpos = GetValNumber(Vals, "SkillReq", Number);
		classfeatpos = GetValNumber(Vals, "GiveFeats", Number);
		featreqpos = GetValNumber(Vals, "FeatReq", Number);
		bonusfeattypepos = GetValNumber(Vals, "BonusFeatType", Number);
		bonusfeatpos = GetValNumber(Vals, "BonusFeats", Number);
		epicfeatpos = GetValNumber(Vals, "EpicFeats", Number);
		spellfailpos = GetValNumber(Vals, "SpellFailure", Number);
		useeffectspos = GetValNumber(Vals, "Effects", Number);
		attachclasspos = GetValNumber(Vals, "AttachClass", Number);
		noeqpos = GetValNumber(Vals, "NoEq", Number);
		psidispos = GetValNumber(Vals, "PsiDisc", Number);
		psicryspos = GetValNumber(Vals, "PsiCrys", Number);
		forceattackpos = GetValNumber(Vals, "ForceAttack", Number);
		forceweapontypepos = GetValNumber(Vals, "ForceWeaponType", Number);
		naturalenhpos = GetValNumber(Vals, "NaturalEnhence", Number);
		derrivepos = GetValNumber(Vals, "Derrive", Number);
		copyspellpos = GetValNumber(Vals, "CopySpells", Number);
		npcpos = GetValNumber(Vals, "NPC", Number);
		spellattrpos = GetValNumber(Vals, "SpellAttr", Number);
		bonusclassskillpos = GetValNumber(Vals, "BonusClassSkills", Number);
		forceweaponpos = GetValNumber(Vals, "ForceWeapon", Number);
		nometalpos = GetValNumber(Vals, "NoMetal", Number);

		for (i = 0;i < ATTRIBUTE_COUNT;i++)
		{
			GetAttributeName(i, AttributeNameShort);
			attr[i] = GetValNumber(Vals, AttributeNameShort, Number);
		}
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in CharSource Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsCharSource*) pChar)->Name = Vals[name];
	sscanf(Vals[tw], "W%" PRINTFINT "", &(((clsCharSource*) pChar)->TW));
	for (i = 0;i < ATTRIBUTE_COUNT;i++)
	{
		((clsCharSource*) pChar)->AttributePriority[i] = atoi(Vals[attr[i]]);
	}
	((clsCharSource*) pChar)->Probability = atoi(Vals[prob]);
	((clsCharSource*) pChar)->GA = atoi(Vals[ga]);
	((clsCharSource*) pChar)->RWRef = atoi(Vals[rwref]);
	((clsCharSource*) pChar)->RWWil = atoi(Vals[rwwil]);
	((clsCharSource*) pChar)->RWZaeh = atoi(Vals[rwzaeh]);
	((clsCharSource*) pChar)->PreferedAttack = atoi(Vals[attack]);
	((clsCharSource*) pChar)->Skills = atoi(Vals[skills]);
	((clsCharSource*) pChar)->Prestige = atoi(Vals[prestige]);
	((clsCharSource*) pChar)->MaxLevel = atoi(Vals[maxlvl]);
	((clsCharSource*) pChar)->SpellType = atoi(Vals[spellpos]);
	((clsCharSource*) pChar)->SpellType2 = atoi(Vals[spelltype2pos]);
	((clsCharSource*) pChar)->IncreaseSpellType = atoi(Vals[incspellpos]);
	
	((clsCharSource*) pChar)->SpontanCast = atoi(Vals[spontanpos]);
	((clsCharSource*) pChar)->EpicFeats = atoi(Vals[epicfeatpos]);

	((clsCharSource*) pChar)->SpontanCast2 = ((clsCharSource*) pChar)->SpontanCast / 2;
	((clsCharSource*) pChar)->SpontanCast &= 1;

	((clsCharSource*) pChar)->Domains = atoi(Vals[domainpos]);
	((clsCharSource*) pChar)->Specialize = atoi(Vals[specialpos]);
	((clsCharSource*) pChar)->PowerType = atoi(Vals[powerpos]);
	((clsCharSource*) pChar)->SpellFailure = atoi(Vals[spellfailpos]);

	((clsCharSource*) pChar)->UseEffects = atoi(Vals[useeffectspos]);

	((clsTempCharSource*) pTempChar)->ReqStr = Vals[reqpos];
	((clsTempCharSource*) pTempChar)->SkillStr = Vals[skillreqpos];
	((clsTempCharSource*) pTempChar)->FeatStr = Vals[featreqpos];

	str_replace(',', ' ', ((clsTempCharSource*) pTempChar)->ReqStr.buffer);
	str_replace(';', 0, ((clsTempCharSource*) pTempChar)->ReqStr.buffer);

	str_replace(';', 0, ((clsTempCharSource*) pTempChar)->FeatStr.buffer);

	str_replace(',', ' ', ((clsTempCharSource*) pTempChar)->SkillStr.buffer);
	str_replace(';', 0, ((clsTempCharSource*) pTempChar)->SkillStr.buffer);

	((clsCharSource*) pChar)->BonusFeatType = Vals[bonusfeattypepos];
	str_replace(';', 0, ((clsCharSource*) pChar)->BonusFeatType.buffer);
	
	((clsCharSource*) pChar)->BonusFeats = Vals[bonusfeatpos];
	str_replace(':', ' ', ((clsCharSource*) pChar)->BonusFeats.buffer);
	str_replace(';', 0, ((clsCharSource*) pChar)->BonusFeats.buffer);

	((clsTempCharSource*) pTempChar)->AttachClass = Vals[attachclasspos];

	((clsCharSource*) pChar)->NoEq = atoi(Vals[noeqpos]);
	((clsCharSource*) pChar)->PsionicDisciple = atoi(Vals[psidispos]);
	((clsCharSource*) pChar)->PsiCrystal = atoi(Vals[psicryspos]);
	((clsCharSource*) pChar)->ForceAttack = atoi(Vals[forceattackpos]);
	((clsCharSource*) pChar)->ForceWeaponType = atoi(Vals[forceweapontypepos]);
	((clsCharSource*) pChar)->NaturalEnhence = atoi(Vals[naturalenhpos]);

	((clsTempCharSource*) pTempChar)->Derrive = Vals[derrivepos];
	((clsTempCharSource*) pTempChar)->CopySpellList = Vals[copyspellpos];

	((clsCharSource*) pChar)->NPC = atoi(Vals[npcpos]);
	((clsCharSource*) pChar)->SpellAttr = atoi(Vals[spellattrpos]);
	((clsCharSource*) pChar)->BonusClassSkills = atoi(Vals[bonusclassskillpos]);

	((clsCharSource*) pChar)->NoMetal = atoi(Vals[nometalpos]);
	((clsTempCharSource*) pTempChar)->ForceWeapon = Vals[forceweaponpos];
	
	if (bnf::bnfparse(Vals[scriptpos], &(((clsCharSource*) pChar)->Script), &ScriptGrammar) ||
		bnf::bnfparse(Vals[classfeatpos], &(((clsCharSource*) pChar)->ClassFeats), &ScriptGrammar))
	{
		qprintf("Error in Character Script %s\n", Vals[name]);
		quitprog();
	}
}

void CharSourceExit()
{
	longint i;
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		freel(Source.CharSource[i].Script);
		freel(Source.CharSource[i].ClassFeats);
	}
	delete[] Source.CharSource;
}
