void SetSpellSource(char** Vals, void* pSpell, void* pTempSpell, longint Number, bool header)
{
	longint i;
	static longint DomainPos[2], DomainLevelPos, SchoolPos, ProbabilityPos, name, convertpos;
	static longint valcount;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number, false);
		}

		DomainPos[0] = GetValNumber(Vals, "Domne", Number);
		DomainPos[1] = GetValNumber(Vals, "Domne2", Number);
		DomainLevelPos = GetValNumber(Vals, "DomneL", Number);
		SchoolPos = GetValNumber(Vals, "Schule", Number);
		ProbabilityPos = GetValNumber(Vals, "Probability", Number);
		name = GetValNumber(Vals, "Name", Number);
		convertpos = GetValNumber(Vals, "Convert", Number);

		valcount = Number;

		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in Spell Source Database (%s)\n", Vals[0]);
		quitprog();
	}

	((clsSpellSource*) pSpell)->Name = Vals[name];
	((clsSpellSource*) pSpell)->Convert = atoi(Vals[convertpos]);
	((clsSpellSource*) pSpell)->ClassLevels = (longint*) mallocl(Source.CharSourceCount * sizeof(longint), "SetSpellSource-ClassLevels");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] != -1)
		{
			((clsSpellSource*) pSpell)->ClassLevels[i] = atoi(Vals[ClassPosition[i]]);
		}
		else
		{
			((clsSpellSource*) pSpell)->ClassLevels[i] = -1;
		}
	}
	((clsSpellSource*) pSpell)->DomainCount = 2;
	if (strcmp(Vals[DomainPos[1]], "-") == 0)
	{
		((clsSpellSource*) pSpell)->DomainCount = 1;
	}
	if (strcmp(Vals[DomainPos[0]], "-") == 0)
	{
		((clsSpellSource*) pSpell)->DomainCount = 0;
	}

	for (i = 0;i < ((clsSpellSource*) pSpell)->DomainCount;i++)
	{
		((clsSpellSource*) pSpell)->Domains[i] = GetDomainNumber(Vals[DomainPos[i]]);
	}
		
	((clsSpellSource*) pSpell)->DomainLevel = atoi(Vals[DomainLevelPos]);
	((clsSpellSource*) pSpell)->School = GetSchoolNumber(Vals[SchoolPos]);
	((clsSpellSource*) pSpell)->Probability = atoi(Vals[ProbabilityPos]);
}

void SetSpellSource2(char** Vals, void* pSpell, void* pTempSpell, longint Number, bool header)
{
	longint i;
	static longint SpellLevelPos[10];
	char pSpellLevel[3];
	char* pTemp;
	longint nChar;
	static longint name;
	static longint valcount;

	if (header)
	{
		name = GetValNumber(Vals, "Name", Number);
		for (i = 0;i < 10;i++)
		{
			itoa((int) i, pSpellLevel, 10);
			SpellLevelPos[i] = GetValNumber(Vals, pSpellLevel, Number);
		}

		valcount = Number;

		return;
	}

	if (Number != valcount)
	{
		qprintf("Invalid Number of Arguments in Spell Source Database (%s)\n", Vals[0]);
		quitprog();
	}

	nChar = GetCharNumber(Vals[name]);
	for (i = 0;i < 10;i++)
	{
		str_replace(';', 0, Vals[SpellLevelPos[i]]);
		pTemp = Vals[SpellLevelPos[i]];
		while (*pTemp)
		{
			Source.SpellSource[GetSpellNumber(pTemp)].ClassLevels[nChar] = i;
			pTemp += strlen(pTemp) + 1;
		}
	}
}

void CopySpellList()
{
	longint i, j, nChar;

	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (TempSource.CharSource[i].CopySpellList != ";")
		{
			nChar = GetCharNumber(TempSource.CharSource[i].CopySpellList.buffer);
			for (j = 0;j < Source.SpellSourceCount;j++)
			{
				Source.SpellSource[j].ClassLevels[i] = Source.SpellSource[j].ClassLevels[nChar];
			}
		}
	}
}

void SpellSourceExit()
{
	longint i;
	for (i = 0;i < Source.SpellSourceCount;i++)
	{
		freel(Source.SpellSource[i].ClassLevels);
	}
	delete[] Source.SpellSource;
}
