#ifndef QON_INCLUDE_DONE
#define QON_INCLUDE_DONE

#include "config.h"

#ifndef QON_NO_AUTOINCLUDES
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <winbase.h>
#include <conio.h>
#include <string.h>
#endif

#ifdef MALLOC_LOG
#ifndef QON_MALLOC_NO_NEW_LOG
	extern void* __cdecl operator new[] (size_t size);
	extern void* __cdecl operator new (size_t size);
	extern void __cdecl operator delete[] (void* pointer);
	extern void __cdecl operator delete (void* pointer);
#endif
#endif

#ifndef QON_NO_NAMESPACE
namespace qon
{
#endif

	//Malloc Log Part
	extern "C" longint CompactSourceAllocated;
	extern "C" longint verbose, logverbose, verbosemax, verboseuse;
	extern "C" unsigned longint dwPageSize;
	extern "C" longint ReserveHigh;

	extern "C" void* fDebugFile;

#include "functions/functions.h"

	//Qprint Part
	extern "C" volatile longint qprint_testset;
#ifdef QON_DISABLE_QPRINTF
	#ifndef qprintf
		#define qprintf if (verbose >= verboseuse) printf
	#endif
	#define qprintf_main printf
	#define qprinta(verbose_this) if (verbosemax >= (verbose_this)) (verboseuse = (verbose_this)) == verboseuse && qprintf_main
#else
#ifdef _AMD64_
	extern "C"
#endif
		longint __cdecl qprintf_main(const void* string, ...);
	#define qprintf qon_testset(&qprint_testset) && qprintf_main
	#define qprinta(verbose_this) if (verbosemax >= (verbose_this)) qon_testset(&qprint_testset) && (verboseuse = (verbose_this)) == verboseuse && qprintf_main
#endif

#define mGetStatic(var, varbool, call) \
	static longint var; \
	static bool varbool = true; \
	if (varbool) \
	{ \
		var = call; \
		varbool = false; \
	}

#define mCheckOverflow(var, limit, name, varname) \
	if (var >= limit) \
	{ \
		qprintf(name " Overflow, Increase " varname "!\n"); \
		qon_quitprog(); \
	}

	extern "C" longint qon_DebugOutput;

#include "script/scriptredir.h"

#include "classes.h"

	//BNF Part
	namespace parser
	{
		longint ParseScript(clsScriptContext* pContext, unsigned char* script, longint depth = 0, char* pThisSymbol = "");
		longint SkipScript(unsigned char* script, longint num = 1);
		longint qon_RedirectSymbols(clsGrammar* pGrammar, longint (*pRedirA)(char*, char*, size_t &AddrPos) = NULL);
	}

#include "malloclog/malloclog.h"
#include "malloclog/realloc.h"


	//String Part
	extern "C" char* EmptyString;
#include "string/string.h"

#ifndef QON_NO_NAMESPACE
}
#endif

#include "includes.h"
#ifndef QON_NO_NAMESPACE
namespace qon
{
#endif

#include "bnf/include.h"

#ifndef QON_NO_NAMESPACE
}
#endif

#else
#error Dual Include
#endif
