#ifdef MALLOC_LOG

struct structMallocLog
{
	void* Pointer;
	char Ident[256];
	size_t Size;
	longint ID;
	LARGE_INTEGER TimeStamp;
	longint vAlloc;
};

char OperatorNewIdent[256];
bool fUseProfiledAlining = true;

structMallocLog MallocLogs[MAX_MALLOC];
longint MallocLogCount = -1;
longint MallocID = 0;

extern "C" longint MaxAlloc;
longint MaxAlloc = 0;

struct structPersistend
{
	longint PersistendID;
	size_t PersistendSize;
	size_t Adress;
};

structPersistend* Persistends;
longint PersistendIDCount = 0;
longint CurMallocID = 0;

longint dwVarCount;
longint* dwVarAccess;
longint* dwPageMap;

int __cdecl ListAlloc(longint Start)
{
	longint i;

	bool found = false;

	if (MallocLogCount > Start)
	{
		for (i = Start;i <= MallocLogCount;i++)
		{
			if (found == false)
			{
				qprintf("Memmory Leak Found\n\n");
				found = true;
			}
			qprintf("\t%" PRINTFINT "\t:%30s (ID: %8" PRINTFINT " - Size: %5" PRINTFINT ")  ", i, MallocLogs[i].Ident, MallocLogs[i].ID, (longint) MallocLogs[i].Size);
			if (MallocLogs[i].Size < 50)
			{
				((char*) MallocLogs[i].Pointer)[MallocLogs[i].Size - 1] = 0;
				qprintf("%s", MallocLogs[i].Pointer);
			}
			qprintf("\n");
		}
		if (found)
		{
			qprintf("Memory Leak Found\n");
			return(-1);
		}
	}
	return(0);
}

void* __cdecl mallocloga(size_t size, char* Ident)
{
	void *tmp, *Pointer;
	longint FoundPage = 0;
	longint ContinousBlocks = 0;
	longint ReserveHigh2 = 0;

	qprinta(DEBUG_ALLOC_VERBOSE)("Allocating %" PRINTFINT " Bytes (%s)\n", size, Ident);

	if (ReserveHigh)
	{
		if (Persistends[CurMallocID].PersistendID == MallocID)
		{
			CurMallocID++;
			ReserveHigh2 = 1;
		}
	}

	if (ReserveHigh2)
	{
		Pointer = tmp = (void*) Persistends[CurMallocID - 1].Adress;
		size = Persistends[CurMallocID - 1].PersistendSize;
	}
	else
	{
		tmp = malloc(size);
		Pointer = tmp;
	}

	if (tmp == 0)
	{
		qprintf("Memmory Allocation Error\n");
		breakpoint("mallocloga");
	}

	if (MallocLogCount < MAX_MALLOC)
	{
		MallocLogCount++;
		if (MallocLogCount > MaxAlloc)
		{
			MaxAlloc = MallocLogCount;
		}
		MallocLogs[MallocLogCount].ID = MallocID++;
		MallocLogs[MallocLogCount].Pointer = Pointer;
		MallocLogs[MallocLogCount].Size = size;
		MallocLogs[MallocLogCount].vAlloc = ReserveHigh2;
		QueryPerformanceCounter(&MallocLogs[MallocLogCount].TimeStamp);
		strcpy(MallocLogs[MallocLogCount].Ident, Ident);
	}
	else
	{
		qprintf("Could not log Memory Allocation\n");
		breakpoint("mallocloga");
	}
	return(Pointer);
}

void __cdecl freeloga(void* Pointer)
{
	signed longint i;
	bool found = false;
	longint vAllocated;
	size_t nAllocated;

	for (i = MallocLogCount;i >= 0;i--)
	{
		if (MallocLogs[i].Pointer == Pointer)
		{
			qprinta(DEBUG_ALLOC_VERBOSE)("Freeing %s\n", MallocLogs[i].Ident);

			vAllocated = MallocLogs[i].vAlloc;
			nAllocated = MallocLogs[i].Size;
			if (i < MallocLogCount)
			{
				CopyMemory(&MallocLogs[i], &MallocLogs[MallocLogCount], sizeof(structMallocLog));
			}
			found = true;
			MallocLogCount--;
			break;
		}
	}
	if (!found)
	{
		qprintf("Freed On non allocated Block\n");
		breakpoint("freeloga");
	}
	else
	{
		if (!vAllocated)
		{
			free(Pointer);
		}
	}
}

void* __cdecl reallocloga(void* Pointer, size_t Size)
{
	longint i;

	for (i = MallocLogCount;i > 0;i--)
	{
		if (MallocLogs[i].Pointer == Pointer)
		{
			if (MallocLogs[i].vAlloc)
			{
				if (Size > MallocLogs[i].Size)
				{
					qprintf("Cannot Realloc Dump Memory\n");
					breakpoint("reallocloga");
				}
				else
				{
					return(Pointer);
				}
			}
			Pointer = realloc(MallocLogs[i].Pointer, Size);
			if (Pointer == 0)
			{
				breakpoint("Memory Allocation Error");
			}
			if (Size > MallocLogs[i].Size)
			{
				MallocLogs[i].Size = Size;
			}
			MallocLogs[i].Pointer = Pointer;
			if (strlen(MallocLogs[i].Ident) < 240)
			{
				strcat(MallocLogs[i].Ident, "-re");
			}
			else if (strstr(MallocLogs[i].Ident + 239, ".") == 0)
			{
				strcat(MallocLogs[i].Ident, "...");
			}
			return(Pointer);
		}
	}
	breakpoint("Cannot realloc unallocated Memory");
	return(NULL);
}

longint __cdecl SaveAllocs(size_t CompactSize, __int64 Start, __int64 End, char* FileName, void* base, unsigned longint base_size, ...)
{
	HANDLE hFile;
	unsigned long int i, j;

	unsigned longint BaseAddr = -1, EndAddr = 0, AddrCount = 0;

	qprintf("Dumping Source...");

	hFile = CreateFile(FileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		qprintf("Could not Open File: %s\n", FileName);
		return(1);
	}

	WriteFile(hFile, "DNDS", 5, &i, NULL);
	WriteFile(hFile, &CompactSize, sizeof(longint), &i, NULL);
	WriteFile(hFile, (void*) VIRTUAL_COMPACT_BASE, (int) CompactSize, &j, NULL);

	if (i != sizeof(longint) || j != (unsigned) CompactSize)
	{
		qprintf("Error Writing File\n");
		CloseHandle(hFile);
		return(1);
	}

	WriteFile(hFile, &base_size, sizeof(longint), &i, NULL);
	WriteFile(hFile, base, (int) base_size, &j, NULL);
	if (i != sizeof(longint) || j != base_size)
	{
		qprintf("Error Writing File\n");
		CloseHandle(hFile);
		return(1);
	}

	
	va_list valist;
	size_t curarg, curarg2;
	va_start(valist, base_size);
	curarg = va_arg(valist, longint);
	while (curarg)
	{
		curarg2 = va_arg(valist, longint);
		WriteFile(hFile, (void*) &curarg2, (longint) sizeof(size_t), &i, NULL);
		WriteFile(hFile, (void*) curarg, (int) curarg2, &j, NULL);
		if (i != sizeof(longint) || j != curarg2)
		{
			qprintf("Error Writing File\n");
			CloseHandle(hFile);
			return(1);
		}
		curarg = va_arg(valist, longint);
	}
	va_end(valist);
	
	CloseHandle(hFile);

	qprintf("Done\n\n");

	return(0);
}

int __cdecl q_compare_structPersistend(const void* a, const void* b)
{
	return ((int) (((structPersistend*) a)->PersistendID - ((structPersistend*) b)->PersistendID));
}

int __cdecl q_compare_structMallocLog(const void* a, const void* b)
{
	return ((int) (((structMallocLog*) a)->ID - ((structMallocLog*) b)->ID));
}

struct clsVarPack
{
	longint dwVarNum;
	size_t dwLen;
	size_t dwPackLen;
	longint Count;
	clsVarPack* AppendVar;
};

int __cdecl q_compare_varPack(const void* a, const void* b)
{
	return ((int) (((clsVarPack*) b)->Count - ((clsVarPack*) a)->Count));
}

size_t BindAlign(size_t Adress, size_t Size, bool force = false)
{
	unsigned longint i = 1;

#ifdef VIRTUAL_ALIGN
	if (!force)
	{
		Size = min(VIRTUAL_ALIGN, Size);
	}
#endif

	while (i < Size)
	{
		i *= 2;
	}

	if (Adress % i)
	{
		Adress += i - Adress % i;
	}

	return(Adress);
}

clsVarPack* VarPacks;
longint dwVarPackCount;

#define MOD_APPENDED 2

void AppendVarPack(longint dwFirst, longint dwSecond)
{
	longint i;
	clsVarPack tmpPack, *pPack;

	for (i = 0;i < dwVarPackCount;i++)
	{
		dwVarAccess[VarPacks[dwFirst].dwVarNum * dwVarCount + i] +=
			dwVarAccess[VarPacks[dwSecond].dwVarNum * dwVarCount + i] / MOD_APPENDED;

	}

	for (i = 0;i < dwVarPackCount;i++)
	{
		dwVarAccess[VarPacks[i].dwVarNum * dwVarCount + VarPacks[dwFirst].dwVarNum] /= MOD_APPENDED;
		dwVarAccess[VarPacks[i].dwVarNum * dwVarCount + VarPacks[dwFirst].dwVarNum] +=
			dwVarAccess[VarPacks[i].dwVarNum * dwVarCount + VarPacks[dwSecond].dwVarNum];
	}

	for (i = 0;i < dwVarCount;i++)
	{
		dwVarAccess[VarPacks[dwSecond].dwVarNum * dwVarCount + i] = 0;
		dwVarAccess[i * dwVarCount + VarPacks[dwSecond].dwVarNum] = 0;
		dwVarAccess[i * dwVarCount + i] = 0;
	}

	dwVarPackCount--;

	CopyMemory(&tmpPack, &VarPacks[dwSecond], sizeof(clsVarPack));
	CopyMemory(&VarPacks[dwSecond], &VarPacks[dwVarPackCount], sizeof(clsVarPack));
	CopyMemory(&VarPacks[dwVarPackCount], &tmpPack, sizeof(clsVarPack));
	
	VarPacks[dwFirst].Count += VarPacks[dwVarPackCount].Count;
	VarPacks[dwFirst].dwPackLen += VarPacks[dwVarPackCount].dwPackLen;
	
	pPack = &VarPacks[dwFirst];
	while (pPack->AppendVar != NULL)
	{
		pPack = pPack->AppendVar;
	}
	pPack->AppendVar = &VarPacks[dwVarPackCount];
}

size_t __cdecl RepackMallocIDS()
{
	longint i, j;
	longint tmpval, maxval;
	longint tmp1, tmp2;
	structPersistend* tmpPersistends;
	clsVarPack* tmpPack;

	VarPacks = (clsVarPack*) malloc(dwVarCount * sizeof(clsVarPack));
	for (i = 0;i < dwVarCount;i++)
	{
		VarPacks[i].dwVarNum = i;
		VarPacks[i].dwLen = VarPacks[i].dwPackLen = Persistends[i].PersistendSize;
		VarPacks[i].AppendVar = NULL;
		VarPacks[i].Count = dwVarAccess[i * dwVarCount + i];
		dwVarAccess[i * dwVarCount + i] = 0;
	}

	dwVarPackCount = dwVarCount;

AppendNext:
	maxval = 0;

#ifdef USE_ASM
#ifdef GNU_ASM
	for (i = 0;i < dwVarPackCount;i++)
	{
		for (j = 0;j < dwVarPackCount;j++)
		{
			if (i != j)
			{
				tmpval = dwVarAccess[VarPacks[i].dwVarNum * dwVarCount + VarPacks[j].dwVarNum];
				if (tmpval > maxval)
				{
					tmp2 = i;
					tmp1 = j;
					maxval = tmpval;
				}
			}
		}
	}
#else

	__asm
	{
		mov ASM_EBX, dwVarAccess
		mov ASM_EAX, dwVarCount
		mul ASM_EAX
		add ASM_EAX, ASM_EBX
		sub ASM_EBX, SIZE_T_SIZE;
		xor ASM_EDI, ASM_EDI
		xor ASM_EDX, ASM_EDX
findpackloop:
		add ASM_EBX, SIZE_T_SIZE;
		cmp ASM_EBX, ASM_EAX
		je findend
		mov ASM_ECX, [ASM_EBX]
		cmp ASM_ECX, ASM_EDX
		jng findpackloop
		mov ASM_EDI, ASM_EBX
		mov ASM_EDX, ASM_ECX
		jmp findpackloop

findend:
		sub ASM_EDI, dwVarAccess
		mov tmp2, ASM_EDI
		mov tmpval, ASM_EDX
	}

	tmp2 /= sizeof(longint);
	tmp1 = tmp2 % dwVarCount;
	tmp2 /= dwVarCount;
	maxval = tmpval;

	for (i = 0;i < dwVarCount;i++)
	{
		if (VarPacks[i].dwVarNum == tmp1)
		{
			tmp1 = i;
		}
	}
	for (i = 0;i < dwVarCount;i++)
	{
		if (VarPacks[i].dwVarNum == tmp2)
		{
			tmp2 = i;
		}
	}
#endif
#else
	for (i = 0;i < dwVarPackCount;i++)
	{
		for (j = 0;j < dwVarPackCount;j++)
		{
			if (i != j)
			{
				tmpval = dwVarAccess[VarPacks[i].dwVarNum * dwVarCount + VarPacks[j].dwVarNum];
				if (tmpval > maxval)
				{
					tmp2 = i;
					tmp1 = j;
					maxval = tmpval;
				}
			}
		}
	}
#endif

	if (maxval)
	{
		qprintf("Merged %" PRINTFINT " of %" PRINTFINT " (%" PRINTFINT ")\n", dwVarCount - dwVarPackCount, dwVarCount, maxval);
		AppendVarPack(tmp1, tmp2);
		if (dwVarPackCount > 1)
		{
			goto AppendNext;
		}
	}

	qsort(VarPacks, dwVarPackCount, sizeof(clsVarPack),
		#ifdef GCC_RUNTIME
			(longint (*) (const void*, const void*))		//GCC Compiler Bug (calls with wrong calling convention)
		#endif
			&q_compare_varPack);

	tmpPersistends = Persistends;
	Persistends = (structPersistend*) malloc(PersistendIDCount * sizeof(structPersistend));

	size_t VirtualCompactCur = VIRTUAL_COMPACT_BASE + 1;
	longint fPackStart;
	j = 0;
	for (i = 0;i < dwVarPackCount;i++)
	{
		tmpPack = &VarPacks[i];
		fPackStart = true;
		do
		{
			CopyMemory(&Persistends[j], &tmpPersistends[tmpPack->dwVarNum], sizeof(structPersistend));
			#ifdef VIRTUAL_ALIGN
				VirtualCompactCur = BindAlign(VirtualCompactCur, Persistends[j].PersistendSize);
			#endif
			#ifdef CACHE_LINE_ALIGN
				if (fUseProfiledAlining)
				{
					if (fPackStart)
					{
						if (VirtualCompactCur % CACHE_LINE_ALIGN && CACHE_LINE_ALIGN - VirtualCompactCur % CACHE_LINE_ALIGN < tmpPack->dwPackLen)
						{
							VirtualCompactCur += CACHE_LINE_ALIGN - VirtualCompactCur % CACHE_LINE_ALIGN;
						}
					}
				}
			#endif
			Persistends[j].Adress = VirtualCompactCur;
			VirtualCompactCur += Persistends[j++].PersistendSize;
			fPackStart = false;
		} while ((tmpPack = tmpPack->AppendVar) != NULL);
	}

	free(tmpPersistends);
	free(VarPacks);

	free(dwVarAccess);
	free(dwPageMap);

	qsort(Persistends, PersistendIDCount, sizeof(structPersistend),
		#ifdef GCC_RUNTIME
			(longint (*) (const void*, const void*))			//GCC Compiler Bug (calls with wrong calling convention)
		#endif
			&q_compare_structPersistend);

	CurMallocID = 0;

	return(VirtualCompactCur - VIRTUAL_COMPACT_BASE);
}

size_t __cdecl PackMallocIDS(longint start)
{
	longint i;
	size_t PersistendSize = 0;
	size_t VirtualCompactCur = VIRTUAL_COMPACT_BASE + 1;

	qsort(MallocLogs, MallocLogCount, sizeof(structMallocLog),
		#ifdef GCC_RUNTIME
			(longint (*) (const void*, const void*))			//GCC Compiler Bug (calls with wrong calling convention)
		#endif
			&q_compare_structMallocLog);

	PersistendIDCount = 0;
	for (i = 1;i <= MallocLogCount;i++)
	{
		if (MallocLogs[i].ID >= start && MallocLogs[i].ID < MallocID)
		{
			PersistendIDCount++;
		}
	}

	Persistends = (structPersistend*) malloc(PersistendIDCount * sizeof(structPersistend));

	PersistendIDCount = 0;

	for (i = 1;i <= MallocLogCount;i++)
	{
		if (MallocLogs[i].ID >= start && MallocLogs[i].ID < MallocID)
		{
			Persistends[PersistendIDCount].PersistendID = MallocLogs[i].ID;
			Persistends[PersistendIDCount].PersistendSize = MallocLogs[i].Size;
#ifdef CACHE_LINE_ALIGN
			if (fUseProfiledAlining)
			{
				VirtualCompactCur = BindAlign(VirtualCompactCur, max(MallocLogs[i].Size, dwPageSize), true);
			}
#ifdef VIRTUAL_ALIGN
			else
			{
				VirtualCompactCur = BindAlign(VirtualCompactCur, MallocLogs[i].Size);
			}
#endif
#else
#ifdef VIRTUAL_ALIGN
			VirtualCompactCur = BindAlign(VirtualCompactCur, MallocLogs[i].Size);
#endif
#endif
			Persistends[PersistendIDCount].Adress = VirtualCompactCur;
			VirtualCompactCur += MallocLogs[i].Size;
			PersistendIDCount++;
		}
	}
	CurMallocID = 0;

	PersistendSize = VirtualCompactCur - VIRTUAL_COMPACT_BASE;

	qsort(Persistends, PersistendIDCount, sizeof(structPersistend),
		#ifdef GCC_RUNTIME
			(longint (*) (const void*, const void*))			//GCC Compiler Bug (calls with wrong calling convention)
		#endif
			&q_compare_structPersistend);

#ifdef CACHE_LINE_ALIGN
	if (fUseProfiledAlining)
	{
		size_t j;
		dwVarCount = PersistendIDCount;
		dwPageMap = (longint*) malloc((PersistendSize / dwPageSize + 1) * sizeof(longint));
		dwPageMap[0] = -1;
		for (i = 0;i < PersistendIDCount;i++)
		{
			for (j = Persistends[i].Adress;j < Persistends[i].Adress + Persistends[i].PersistendSize;j += dwPageSize)
			{
				dwPageMap[(j - VIRTUAL_COMPACT_BASE) / dwPageSize] = i;
			}
		}
		dwVarAccess = (longint*) malloc(dwVarCount * dwVarCount * sizeof(longint));
		ZeroMemory(dwVarAccess, dwVarCount * dwVarCount * sizeof(longint));
	}
#endif

	return(PersistendSize);
}

void __cdecl ReleaseMallocIDS()
{
	free(Persistends);
	PersistendIDCount = 0;
	CurMallocID = 0;
}

void* __cdecl LimitedAlloc(size_t size, longint AttachBlocks)
{
	static longint used = 0;
	if (used)
	{
		qprintf("Cann call Limited alloc only once\n");
		breakpoint("LimitedAlloc");
	}
	used = 1;

	size_t allocsize = size % dwPageSize;
	allocsize = dwPageSize - allocsize;
	allocsize += size;

	size_t reservesize = allocsize % 65536;
	reservesize = 65536 - reservesize;
	reservesize += allocsize + AttachBlocks * 65536;

	size_t rVal;
	void* ptr;
	rVal = (size_t) VirtualAlloc((void*) (900 * 1024 * 1024), reservesize, MEM_RESERVE, PAGE_NOACCESS);
	rVal = (size_t) VirtualAlloc((void*) (900 * 1024 * 1024), allocsize, MEM_COMMIT, PAGE_READWRITE);
	rVal = (size_t) VirtualAlloc((void*) (900 * 1024 * 1024 + allocsize), reservesize - allocsize, MEM_COMMIT, PAGE_NOACCESS);
	ptr = (void*) (900 * 1024 * 1024 + allocsize - size);

	return(ptr);
}

#endif