#ifndef MALLOCLOG_H_INCLUDED

extern "C" unsigned longint dwMemAccessCount;
extern "C" longint dwMemAccessMax;
extern "C" bool fUseProfiledAlining;

#ifdef MALLOC_LOG
	extern "C" int __cdecl ListAlloc(longint Start = 0);
	extern "C" longint __cdecl SaveAllocs(size_t CompactSize, __int64 Start, __int64 End, char* FileName, void* base, unsigned longint base_size, ...);
	extern "C" size_t __cdecl PackMallocIDS(longint start);
	extern "C" size_t __cdecl RepackMallocIDS();
	extern "C" void __cdecl ReleaseMallocIDS();
	extern "C" void* __cdecl LimitedAlloc(unsigned longint size, longint AttachBlocks);

	extern "C" longint MallocLogCount;
	extern "C" longint MallocID;

	#define freel(Pointer) freeloga(Pointer)
	#define mallocl(size, ident) mallocloga(size, ident)
	#define reallocl(pointer, size) reallocloga(pointer, size)
	#define SetNewIdent(ident) strcpy(OperatorNewIdent + 6, ident)

	extern "C" longint* dwVarAccess;
	extern "C" longint* dwPageMap;
	extern "C" longint dwVarCount;

#define QON_EXPORT_MALLOC_LOG
#else
	#ifdef CHECK_MALLOC
		#ifdef QON_THREAD_SAFE
			#define mallocl(size, idenx) qon_checkmalloc(malloc(size))
			#define reallocl(pointer, size) qon_checkmalloc(realloc(pointer, size))
		#else
			#define mallocl(size, ident) ((mallocLogATemp = malloc(size)) ? mallocLogATemp : (void*) breakpoint("malloc"))
			#define reallocl(pointer, size) ((mallocLogATemp = realloc(pointer, size)) ? mallocLogATemp : (void*) breakpoint("malloc"))
		#endif
	#else
		#define mallocl(size, ident) malloc(size)
		#define reallocl(pointer, size) realloc(pointer, size)
	#endif

	#define freel(lpPtr) free(lpPtr)
	#define SetNewIdent(ident)

	extern "C" void* mallocLogATemp;
#endif

#ifdef QON_EXPORT_MALLOC_LOG
	extern "C" void* __cdecl mallocloga(size_t size, char* Ident);
	extern "C" void __cdecl freeloga(void* Pointer);
	extern "C" void* __cdecl reallocloga(void* Pointer, size_t Size);
	extern "C" char OperatorNewIdent[256];
#endif

#define MALLOCLOG_H_INCLUDED

#endif

#ifndef CALLED_FROM_GLOBAL_H

#endif
