LPVOID vAlloc;

longint ReAlloc(char* FileName, void* base, unsigned longint base_size, ...)
{
	HANDLE hFile;

	unsigned longint CompactSize;
	unsigned longint Thisbase_size;
	DWORD i, j, k;

	bool FileOpened = false;

	qprintf("Loading Source Dump...");

	try
	{
		hFile = CreateFile(FileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
		{
			throw((char*) "Could not open File\n");
		}
		FileOpened = true;
		SetFilePointer(hFile, 5, 0, FILE_BEGIN);
		ReadFile(hFile, &CompactSize, sizeof(longint), &i, NULL);

		if (i != sizeof(longint))
		{
			throw((char*) "Error reading File\n");
		}

		if (VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_RESERVE, PAGE_READWRITE) == NULL || VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_COMMIT, PAGE_READWRITE) == NULL)
		{
			throw((char*) "Memmory Allocation Error\n");
		}
		CompactSourceAllocated = 1;

		ReadFile(hFile, (void*) VIRTUAL_COMPACT_BASE, (int) CompactSize, &i, NULL);
		if (i != CompactSize)
		{
			throw((char*) "Could not read file\n");
		}

		ReadFile(hFile, &Thisbase_size, sizeof(longint), &j, NULL);

		if (Thisbase_size != base_size)
		{
			throw((char*) "Size of Source Class Differs, Dump too old?\n");
		}

		ReadFile(hFile, base, (int) base_size, &k, NULL);
		if (j != sizeof(longint) || k != base_size)
		{
			throw((char*) "Error Reading File\n");
		}

		va_list valist;
		size_t curarg;
 		va_start(valist, base_size);
		curarg = va_arg(valist, size_t);
		while (curarg)
		{
			ReadFile(hFile, &j, sizeof(longint), &k, NULL);
			if (k != sizeof(longint))
			{
				throw((char*) "Error Reading File\n");
			}

			*((void**) curarg) = mallocl(j, "ReAlloc-curarg");
			ReadFile(hFile, *((void**) curarg), j, &k, NULL);
			if (j != k)
			{
				throw((char*) "Error Reading File\n");
			}

			curarg = va_arg(valist, longint);
		}
		va_end(valist);

		if (GetFileSize(hFile, NULL) != SetFilePointer(hFile, 0, NULL, FILE_CURRENT))
		{
			throw((char*) "Dump File Size did not fit\n");
		}
	}
	catch(char* text)
	{
		if (FileOpened)
		{
			CloseHandle(hFile);
		}
		if (CompactSourceAllocated)
		{
			VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE);
			CompactSourceAllocated = 0;
		}
		qprintf(text);
		return(1);
	}

	qprintf("Done\n");

	CloseHandle(hFile);

	return(0);
}